// A Bison parser, made by GNU Bison 3.0.4.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


// First part of user declarations.
#line 1 "lib/parser.y" // lalr1.cc:404

#include <cstdio>
#include <iostream>

#include "Statements"

using namespace std;


int yylex(void);
void yyerror(const char * msg);

std::string filename;
SourceLocation createLocation(int line,int column);

extern FILE * yyin;

#line 54 "lib/Parser.cpp" // lalr1.cc:404

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "Parser.h"

// User implementation prologue.

#line 68 "lib/Parser.cpp" // lalr1.cc:412


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace yy {
#line 154 "lib/Parser.cpp" // lalr1.cc:479

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
   Parser ::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
   Parser :: Parser  ()
#if YYDEBUG
     :yydebug_ (false),
      yycdebug_ (&std::cerr)
#endif
  {}

   Parser ::~ Parser  ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/



  // by_state.
  inline
   Parser ::by_state::by_state ()
    : state (empty_state)
  {}

  inline
   Parser ::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
   Parser ::by_state::clear ()
  {
    state = empty_state;
  }

  inline
  void
   Parser ::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  inline
   Parser ::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
   Parser ::symbol_number_type
   Parser ::by_state::type_get () const
  {
    if (state == empty_state)
      return empty_symbol;
    else
      return yystos_[state];
  }

  inline
   Parser ::stack_symbol_type::stack_symbol_type ()
  {}


  inline
   Parser ::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
      switch (that.type_get ())
    {
      case 38: // assignStmt
        value.move< AssignStatement* > (that.value);
        break;

      case 34: // stmtList
        value.move< CompoundStatement* > (that.value);
        break;

      case 36: // expr
        value.move< Expr* > (that.value);
        break;

      case 40: // forStmt
        value.move< ForStatement* > (that.value);
        break;

      case 39: // ifStmt
        value.move< IfStatement* > (that.value);
        break;

      case 35: // stmt
        value.move< Statement* > (that.value);
        break;

      case 25: // INTEGER
      case 26: // FLOAT
        value.move< int > (that.value);
        break;

      case 24: // STRING
      case 27: // IDENTIFIER
      case 28: // OPERATOR
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    // that is emptied.
    that.type = empty_symbol;
  }

  inline
   Parser ::stack_symbol_type&
   Parser ::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
      switch (that.type_get ())
    {
      case 38: // assignStmt
        value.copy< AssignStatement* > (that.value);
        break;

      case 34: // stmtList
        value.copy< CompoundStatement* > (that.value);
        break;

      case 36: // expr
        value.copy< Expr* > (that.value);
        break;

      case 40: // forStmt
        value.copy< ForStatement* > (that.value);
        break;

      case 39: // ifStmt
        value.copy< IfStatement* > (that.value);
        break;

      case 35: // stmt
        value.copy< Statement* > (that.value);
        break;

      case 25: // INTEGER
      case 26: // FLOAT
        value.copy< int > (that.value);
        break;

      case 24: // STRING
      case 27: // IDENTIFIER
      case 28: // OPERATOR
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
   Parser ::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
   Parser ::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    // Avoid a (spurious) G++ 4.8 warning about "array subscript is
    // below array bounds".
    if (yysym.empty ())
      std::abort ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
   Parser ::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
   Parser ::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
   Parser ::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
   Parser ::debug_stream () const
  {
    return *yycdebug_;
  }

  void
   Parser ::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


   Parser ::debug_level_type
   Parser ::debug_level () const
  {
    return yydebug_;
  }

  void
   Parser ::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline  Parser ::state_type
   Parser ::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
   Parser ::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
   Parser ::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
   Parser ::parse ()
  {
    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            symbol_type yylookahead (yylex ());
            yyla.move (yylookahead);
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
        switch (yyr1_[yyn])
    {
      case 38: // assignStmt
        yylhs.value.build< AssignStatement* > ();
        break;

      case 34: // stmtList
        yylhs.value.build< CompoundStatement* > ();
        break;

      case 36: // expr
        yylhs.value.build< Expr* > ();
        break;

      case 40: // forStmt
        yylhs.value.build< ForStatement* > ();
        break;

      case 39: // ifStmt
        yylhs.value.build< IfStatement* > ();
        break;

      case 35: // stmt
        yylhs.value.build< Statement* > ();
        break;

      case 25: // INTEGER
      case 26: // FLOAT
        yylhs.value.build< int > ();
        break;

      case 24: // STRING
      case 27: // IDENTIFIER
      case 28: // OPERATOR
        yylhs.value.build< std::string > ();
        break;

      default:
        break;
    }


      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 3:
#line 61 "lib/parser.y" // lalr1.cc:859
    { CompoundStatement* stmt = yystack_[1].value.as< CompoundStatement* > (); stmt.setLastStatement(yystack_[0].value.as< Statement* > ()); yylhs.value.as< CompoundStatement* > () = stmt; }
#line 632 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 4:
#line 62 "lib/parser.y" // lalr1.cc:859
    { CompoundStatement* stmt = new CompoundStatement(); stmt.setLastStatement(yystack_[0].value.as< Statement* > ()); yylhs.value.as< CompoundStatement* > () = stmt; }
#line 638 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 7:
#line 66 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Statement* > () = new WhileStatement(yystack_[4].value.as< Expr* > (), yystack_[2].value.as< CompoundStatement* > (), createLocation(yylhs.location.first_line, yylhs.location.first_column)); }
#line 644 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 8:
#line 67 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Statement* > () = new DoStatement(yystack_[3].value.as< CompoundStatement* > (), yystack_[0].value.as< Expr* > (), createLocation(yystack_[5].location.first_line, yystack_[5].location.first_column), createLocation(yystack_[0].location.first_line, yystack_[0].location.first_column)); }
#line 650 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 12:
#line 71 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Statement* > () = new BreakStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column)); }
#line 656 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 13:
#line 72 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Statement* > () = new ReturnStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column)); }
#line 662 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 14:
#line 73 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Statement* > () = new StopStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column)); }
#line 668 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 17:
#line 77 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Expr* > () = new StringLiteralExpr(yystack_[0].value.as< std::string > (), createLocation(yystack_[0].location.first_line, yystack_[0].location.first_column)); }
#line 674 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 18:
#line 78 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Expr* > () = new IntegerLiteralExpr(yystack_[0].value.as< int > (), createLocation(yystack_[0].location.first_line, yystack_[0].location.first_column)) }
#line 680 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 19:
#line 79 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Expr* > () = new FloatLiteralExpr(yystack_[0].value.as< int > (), createLocation(yystack_[0].location.first_line, yystack_[0].location.first_column)) }
#line 686 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 20:
#line 80 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< Expr* > () = new BinaryOperatorExpr(yystack_[2].value.as< Expr* > (), yystack_[0].value.as< Expr* > (), BinaryOperatorExpr::getStrOpcode(yystack_[1].value.as< std::string > ())); }
#line 692 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 23:
#line 86 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< IfStatement* > () = new IfStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column), yystack_[6].value.as< Expr* > (), yystack_[2].value.as< CompoundStatement* > ()); }
#line 698 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 24:
#line 87 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< IfStatement* > () = new IfStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column), yystack_[10].value.as< Expr* > (), yystack_[6].value.as< CompoundStatement* > (), createLocation(yystack_[2].location.first_line, yystack_[2].location.first_column), yystack_[2].value.as< CompoundStatement* > ()); }
#line 704 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 25:
#line 88 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< IfStatement* > () = new IfStatement(yystack_[2].value.as< Expr* > (), yystack_[0].value.as< AssignStatement* > ()); }
#line 710 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 26:
#line 90 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< ForStatement* > () = new ForStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column), yystack_[6].value.as< AssignStatement* > (), yystack_[4].value.as< Expr* > (), yystack_[2].value.as< CompoundStatement* > ());}
#line 716 "lib/Parser.cpp" // lalr1.cc:859
    break;

  case 27:
#line 91 "lib/parser.y" // lalr1.cc:859
    { yylhs.value.as< ForStatement* > () = new ForStatement(createLocation(yylhs.location.first_line, yylhs.location.first_column), yystack_[8].value.as< AssignStatement* > (), yystack_[6].value.as< Expr* > (), yystack_[2].value.as< CompoundStatement* > (), yystack_[4].value.as< Expr* > ());}
#line 722 "lib/Parser.cpp" // lalr1.cc:859
    break;


#line 726 "lib/Parser.cpp" // lalr1.cc:859
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state, yyla));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
   Parser ::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
   Parser ::yysyntax_error_ (state_type yystate, const symbol_type& yyla) const
  {
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (!yyla.empty ())
      {
        int yytoken = yyla.type_get ();
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char  Parser ::yypact_ninf_ = -23;

  const signed char  Parser ::yytable_ninf_ = -1;

  const short int
   Parser ::yypact_[] =
  {
     169,   -18,    -2,    -2,    -2,     4,     4,   -23,   -23,   -23,
     -23,   -23,   -23,   -23,    14,   169,   -23,    27,   -23,   -23,
     -23,   -23,   169,   -22,   -21,     0,    10,   -23,   -23,   -23,
     -23,    -2,     4,    -2,    43,   169,    28,    -2,   -12,   -23,
     -23,    33,    64,    12,   -13,    -2,    36,   169,    -2,   169,
     -12,   -23,    85,   -11,   106,    46,   169,    35,    20,   -23,
     127,   -23,   169,    54,   148,   -23,    47,   -23
  };

  const unsigned char
   Parser ::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,    12,    13,    14,
      17,    18,    19,    21,     0,     2,     4,    15,    16,     5,
       6,     9,     0,     0,     0,     0,     0,    10,    11,     1,
       3,     0,     0,     0,     0,     0,     0,     0,    20,    22,
      25,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       8,     7,     0,     0,     0,     0,     0,     0,     0,    23,
       0,    26,     0,     0,     0,    27,     0,    24
  };

  const signed char
   Parser ::yypgoto_[] =
  {
     -23,   -23,   -14,   -15,    -1,     6,     1,   -23,   -23
  };

  const signed char
   Parser ::yydefgoto_[] =
  {
      -1,    14,    15,    16,    17,    18,    19,    20,    21
  };

  const unsigned char
   Parser ::yytable_[] =
  {
      30,    23,    24,    25,    48,    26,    31,    31,    34,    35,
      36,    27,    28,    22,    29,    31,    31,    31,    49,    30,
      56,    42,    10,    11,    12,    13,    37,    30,    31,    32,
      38,    13,    25,    52,    40,    54,    44,    30,    39,    30,
      43,    45,    60,    47,    50,    30,    51,    53,    64,    30,
       1,    62,     2,    61,     3,    31,    32,    33,     4,    58,
      59,    67,     5,     6,     7,     8,     9,    10,    11,    12,
      13,     1,    65,     2,    41,     3,     0,     0,     0,     4,
       0,     0,     0,     5,     6,     7,     8,     9,    10,    11,
      12,    13,     1,     0,     2,    46,     3,     0,     0,     0,
       4,     0,     0,     0,     5,     6,     7,     8,     9,    10,
      11,    12,    13,     1,     0,     2,    55,     3,     0,     0,
       0,     4,     0,     0,     0,     5,     6,     7,     8,     9,
      10,    11,    12,    13,     1,     0,     2,    57,     3,     0,
       0,     0,     4,     0,     0,     0,     5,     6,     7,     8,
       9,    10,    11,    12,    13,     1,     0,     2,    63,     3,
       0,     0,     0,     4,     0,     0,     0,     5,     6,     7,
       8,     9,    10,    11,    12,    13,     1,     0,     2,    66,
       3,     0,     0,     0,     4,     0,     0,     0,     5,     6,
       7,     8,     9,    10,    11,    12,    13
  };

  const signed char
   Parser ::yycheck_[] =
  {
      15,     2,     3,     4,    17,     4,    28,    28,    22,    31,
      31,     5,     6,    31,     0,    28,    28,    28,    31,    34,
      31,    35,    24,    25,    26,    27,    16,    42,    28,    29,
      31,    27,    33,    47,    33,    49,    37,    52,    32,    54,
      12,     8,    56,    31,    45,    60,    10,    48,    62,    64,
       7,    31,     9,    18,    11,    28,    29,    30,    15,    13,
      14,    14,    19,    20,    21,    22,    23,    24,    25,    26,
      27,     7,    18,     9,    31,    11,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    19,    20,    21,    22,    23,    24,    25,
      26,    27,     7,    -1,     9,    31,    11,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    19,    20,    21,    22,    23,    24,
      25,    26,    27,     7,    -1,     9,    31,    11,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     7,    -1,     9,    31,    11,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    19,    20,    21,    22,
      23,    24,    25,    26,    27,     7,    -1,     9,    31,    11,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    19,    20,    21,
      22,    23,    24,    25,    26,    27,     7,    -1,     9,    31,
      11,    -1,    -1,    -1,    15,    -1,    -1,    -1,    19,    20,
      21,    22,    23,    24,    25,    26,    27
  };

  const unsigned char
   Parser ::yystos_[] =
  {
       0,     7,     9,    11,    15,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    33,    34,    35,    36,    37,    38,
      39,    40,    31,    36,    36,    36,    38,    37,    37,     0,
      35,    28,    29,    30,    34,    31,    31,    16,    36,    37,
      38,    31,    34,    12,    36,     8,    31,    31,    17,    31,
      36,    10,    34,    36,    34,    31,    31,    31,    13,    14,
      34,    18,    31,    31,    34,    18,    31,    14
  };

  const unsigned char
   Parser ::yyr1_[] =
  {
       0,    32,    33,    34,    34,    35,    35,    35,    35,    35,
      35,    35,    35,    35,    35,    35,    36,    36,    36,    36,
      36,    37,    38,    39,    39,    39,    40,    40
  };

  const unsigned char
   Parser ::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     6,     6,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     8,    12,     3,     8,    10
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const  Parser ::yytname_[] =
  {
  "$end", "error", "$undefined", "'-'", "'+'", "'*'", "'/'", "DO",
  "LPWHILE", "WHILE", "WHILEEND", "IF", "THEN", "ELSE", "IFEND", "FOR",
  "TO", "STEP", "NEXT", "GOTO", "LABEL", "BREAK", "RETURN", "STOP",
  "STRING", "INTEGER", "FLOAT", "IDENTIFIER", "OPERATOR", "ASSIGN",
  "IMPLIES", "EOL", "$accept", "program", "stmtList", "stmt", "expr",
  "identifier", "assignStmt", "ifStmt", "forStmt", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned char
   Parser ::yyrline_[] =
  {
       0,    59,    59,    61,    62,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    76,    77,    78,    79,
      80,    82,    84,    86,    87,    88,    90,    91
  };

  // Print the state stack on the debug stream.
  void
   Parser ::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
   Parser ::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG



} // yy
#line 1155 "lib/Parser.cpp" // lalr1.cc:1167
#line 92 "lib/parser.y" // lalr1.cc:1168


void yyerror(const char * msg)
{
    cerr << "line " << lineNumber << ": " << msg << endl;
}

SourceLocation createLocation(int line,int column)
{
    return SourceLocation(filename, line, column);
}


AST* parse_str(std::string str)
{
    if(argc>1)
        yyin=fopen(argv[1],"r"); // check result !!!
    lineNumber=1;
    if(!yyparse())
        cerr << "Success" << endl;
    return(0);
}
